import BaseStore from '@src/stores/base';

export default class UserStore extends BaseStore {
  list(params) {
    return this.apiGet('/user/list', params);
  }

  get(params) {
    return this.apiPost('/user/detail', params);
  }

  add(params) {
    return this.apiPost('/user/add', params);
  }

  edit(params) {
    return this.apiPut('/user/edit', params);
  }

  del(params) {
    return this.apiDel('/user/delete', params);
  }

  listAsk(params) {
    return this.apiGet('/user/ask/list', params);
  }

  editAsk(params) {
    return this.apiPut('/user/ask/edit', params);
  }

  detailAsk(params) {
    return this.apiGet('/user/ask/detail', params);
  }

  listPreview(params) {
    return this.apiGet('/user/preview/list', params);
  }
}

export const User = new UserStore({ key: 'users' });
