import React from 'react';
import './index.less';

function Input(props) {
  const { className = '', size = 'basic', placeholder, disabled, radius, width, onChange } = props;
  return (
    <div
      style={{ width: width || '' }}
      className={`input ${className} ${size} ${disabled ? 'disabled' : ''}  ${radius ? 'radius' : ''}`}
    >
      <input placeholder={placeholder} disabled={disabled} onChange={() => onChange && onChange()} />
    </div>
  );
}
Input.propTypes = {};
export default Input;
