package com.qxgmat.data.dao.entity;

import com.alibaba.fastjson.JSONObject;
import java.io.Serializable;
import java.util.Date;
import javax.persistence.*;

@Table(name = "user_report")
public class UserReport implements Serializable {
    @Id
    @Column(name = "`id`")
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;

    /**
     * 用户id
     */
    @Column(name = "`user_id`")
    private Integer userId;

    /**
     * 用户组卷id
     */
    @Column(name = "`paper_id`")
    private Integer paperId;

    /**
     * 对应模块：exercise，examination，sentence, homework_preview
     */
    @Column(name = "`module`")
    private String module;

    @Column(name = "`module_id`")
    private Integer moduleId;

    /**
     * 总题目数
     */
    @Column(name = "`total_number`")
    private Integer totalNumber;

    /**
     * 预计时常/总时长
     */
    @Column(name = "`total_time`")
    private Integer totalTime;

    /**
     * 已做题目数
     */
    @Column(name = "`user_number`")
    private Integer userNumber;

    /**
     * 已用时长
     */
    @Column(name = "`user_time`")
    private Integer userTime;

    /**
     * 题目编号id列表：json
     */
    @Column(name = "`question_no_ids`")
    private Integer[] questionNoIds;

    /**
     * 正确题目数
     */
    @Column(name = "`correct_number`")
    private Integer correctNumber;

    /**
     * 完成答题时间
     */
    @Column(name = "`finish_time`")
    private Date finishTime;

    /**
     * 详细信息: json
     */
    @Column(name = "`detail`")
    private JSONObject detail;

    @Column(name = "`create_time`")
    private Date createTime;

    private static final long serialVersionUID = 1L;

    /**
     * @return id
     */
    public Integer getId() {
        return id;
    }

    /**
     * @param id
     */
    public void setId(Integer id) {
        this.id = id;
    }

    /**
     * 获取用户id
     *
     * @return user_id - 用户id
     */
    public Integer getUserId() {
        return userId;
    }

    /**
     * 设置用户id
     *
     * @param userId 用户id
     */
    public void setUserId(Integer userId) {
        this.userId = userId;
    }

    /**
     * 获取用户组卷id
     *
     * @return paper_id - 用户组卷id
     */
    public Integer getPaperId() {
        return paperId;
    }

    /**
     * 设置用户组卷id
     *
     * @param paperId 用户组卷id
     */
    public void setPaperId(Integer paperId) {
        this.paperId = paperId;
    }

    /**
     * 获取对应模块：exercise，examination，sentence, homework_preview
     *
     * @return module - 对应模块：exercise，examination，sentence, homework_preview
     */
    public String getModule() {
        return module;
    }

    /**
     * 设置对应模块：exercise，examination，sentence, homework_preview
     *
     * @param module 对应模块：exercise，examination，sentence, homework_preview
     */
    public void setModule(String module) {
        this.module = module;
    }

    /**
     * @return module_id
     */
    public Integer getModuleId() {
        return moduleId;
    }

    /**
     * @param moduleId
     */
    public void setModuleId(Integer moduleId) {
        this.moduleId = moduleId;
    }

    /**
     * 获取总题目数
     *
     * @return total_number - 总题目数
     */
    public Integer getTotalNumber() {
        return totalNumber;
    }

    /**
     * 设置总题目数
     *
     * @param totalNumber 总题目数
     */
    public void setTotalNumber(Integer totalNumber) {
        this.totalNumber = totalNumber;
    }

    /**
     * 获取预计时常/总时长
     *
     * @return total_time - 预计时常/总时长
     */
    public Integer getTotalTime() {
        return totalTime;
    }

    /**
     * 设置预计时常/总时长
     *
     * @param totalTime 预计时常/总时长
     */
    public void setTotalTime(Integer totalTime) {
        this.totalTime = totalTime;
    }

    /**
     * 获取已做题目数
     *
     * @return user_number - 已做题目数
     */
    public Integer getUserNumber() {
        return userNumber;
    }

    /**
     * 设置已做题目数
     *
     * @param userNumber 已做题目数
     */
    public void setUserNumber(Integer userNumber) {
        this.userNumber = userNumber;
    }

    /**
     * 获取已用时长
     *
     * @return user_time - 已用时长
     */
    public Integer getUserTime() {
        return userTime;
    }

    /**
     * 设置已用时长
     *
     * @param userTime 已用时长
     */
    public void setUserTime(Integer userTime) {
        this.userTime = userTime;
    }

    /**
     * 获取题目编号id列表：json
     *
     * @return question_no_ids - 题目编号id列表：json
     */
    public Integer[] getQuestionNoIds() {
        return questionNoIds;
    }

    /**
     * 设置题目编号id列表：json
     *
     * @param questionNoIds 题目编号id列表：json
     */
    public void setQuestionNoIds(Integer[] questionNoIds) {
        this.questionNoIds = questionNoIds;
    }

    /**
     * 获取正确题目数
     *
     * @return correct_number - 正确题目数
     */
    public Integer getCorrectNumber() {
        return correctNumber;
    }

    /**
     * 设置正确题目数
     *
     * @param correctNumber 正确题目数
     */
    public void setCorrectNumber(Integer correctNumber) {
        this.correctNumber = correctNumber;
    }

    /**
     * 获取完成答题时间
     *
     * @return finish_time - 完成答题时间
     */
    public Date getFinishTime() {
        return finishTime;
    }

    /**
     * 设置完成答题时间
     *
     * @param finishTime 完成答题时间
     */
    public void setFinishTime(Date finishTime) {
        this.finishTime = finishTime;
    }

    /**
     * 获取详细信息: json
     *
     * @return detail - 详细信息: json
     */
    public JSONObject getDetail() {
        return detail;
    }

    /**
     * 设置详细信息: json
     *
     * @param detail 详细信息: json
     */
    public void setDetail(JSONObject detail) {
        this.detail = detail;
    }

    /**
     * @return create_time
     */
    public Date getCreateTime() {
        return createTime;
    }

    /**
     * @param createTime
     */
    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", id=").append(id);
        sb.append(", userId=").append(userId);
        sb.append(", paperId=").append(paperId);
        sb.append(", module=").append(module);
        sb.append(", moduleId=").append(moduleId);
        sb.append(", totalNumber=").append(totalNumber);
        sb.append(", totalTime=").append(totalTime);
        sb.append(", userNumber=").append(userNumber);
        sb.append(", userTime=").append(userTime);
        sb.append(", questionNoIds=").append(questionNoIds);
        sb.append(", correctNumber=").append(correctNumber);
        sb.append(", finishTime=").append(finishTime);
        sb.append(", detail=").append(detail);
        sb.append(", createTime=").append(createTime);
        sb.append("]");
        return sb.toString();
    }

    public static UserReport.Builder builder() {
        return new UserReport.Builder();
    }

    public static class Builder {
        private UserReport obj;

        public Builder() {
            this.obj = new UserReport();
        }

        /**
         * @param id
         */
        public Builder id(Integer id) {
            obj.setId(id);
            return this;
        }

        /**
         * 设置用户id
         *
         * @param userId 用户id
         */
        public Builder userId(Integer userId) {
            obj.setUserId(userId);
            return this;
        }

        /**
         * 设置用户组卷id
         *
         * @param paperId 用户组卷id
         */
        public Builder paperId(Integer paperId) {
            obj.setPaperId(paperId);
            return this;
        }

        /**
         * 设置对应模块：exercise，examination，sentence, homework_preview
         *
         * @param module 对应模块：exercise，examination，sentence, homework_preview
         */
        public Builder module(String module) {
            obj.setModule(module);
            return this;
        }

        /**
         * @param moduleId
         */
        public Builder moduleId(Integer moduleId) {
            obj.setModuleId(moduleId);
            return this;
        }

        /**
         * 设置总题目数
         *
         * @param totalNumber 总题目数
         */
        public Builder totalNumber(Integer totalNumber) {
            obj.setTotalNumber(totalNumber);
            return this;
        }

        /**
         * 设置预计时常/总时长
         *
         * @param totalTime 预计时常/总时长
         */
        public Builder totalTime(Integer totalTime) {
            obj.setTotalTime(totalTime);
            return this;
        }

        /**
         * 设置已做题目数
         *
         * @param userNumber 已做题目数
         */
        public Builder userNumber(Integer userNumber) {
            obj.setUserNumber(userNumber);
            return this;
        }

        /**
         * 设置已用时长
         *
         * @param userTime 已用时长
         */
        public Builder userTime(Integer userTime) {
            obj.setUserTime(userTime);
            return this;
        }

        /**
         * 设置题目编号id列表：json
         *
         * @param questionNoIds 题目编号id列表：json
         */
        public Builder questionNoIds(Integer[] questionNoIds) {
            obj.setQuestionNoIds(questionNoIds);
            return this;
        }

        /**
         * 设置正确题目数
         *
         * @param correctNumber 正确题目数
         */
        public Builder correctNumber(Integer correctNumber) {
            obj.setCorrectNumber(correctNumber);
            return this;
        }

        /**
         * 设置完成答题时间
         *
         * @param finishTime 完成答题时间
         */
        public Builder finishTime(Date finishTime) {
            obj.setFinishTime(finishTime);
            return this;
        }

        /**
         * 设置详细信息: json
         *
         * @param detail 详细信息: json
         */
        public Builder detail(JSONObject detail) {
            obj.setDetail(detail);
            return this;
        }

        /**
         * @param createTime
         */
        public Builder createTime(Date createTime) {
            obj.setCreateTime(createTime);
            return this;
        }

        public UserReport build() {
            return this.obj;
        }
    }
}