package com.qxgmat.service.inline;

import com.github.pagehelper.Page;
import com.nuliji.tools.AbstractService;
import com.nuliji.tools.PageResult;
import com.nuliji.tools.exception.ParameterException;
import com.nuliji.tools.exception.SystemException;
import com.qxgmat.data.dao.UserQuestionMapper;
import com.qxgmat.data.dao.entity.UserQuestion;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collection;
import java.util.List;

@Service
public class UserQuestionService extends AbstractService {
    private static final Logger logger = LoggerFactory.getLogger(UserQuestionService.class);

    @Resource
    private UserQuestionMapper userQuestionMapper;

    /**
     * 用户错题记录：相同题目的最后一次做题记录及其编号
     * @param page
     * @param size
     * @param userId
     * @return
     */
    public PageResult<UserQuestion> listError(int page, int size, Integer userId){
        return new PageResult<>(null, 0);
    }

    public UserQuestion add(UserQuestion question){
        int result = insert(userQuestionMapper, question);
        question = one(userQuestionMapper, question.getId());
        if(question == null){
            throw new SystemException("用户题目添加失败");
        }
        return question;
    }

    public UserQuestion edit(UserQuestion question){
        UserQuestion in = one(userQuestionMapper, question.getId());
        if(in == null){
            throw new ParameterException("用户题目不存在");
        }
        int result = update(userQuestionMapper, question);
        return question;
    }

    public boolean delete(Number id){
        UserQuestion in = one(userQuestionMapper, id);
        if(in == null){
            throw new ParameterException("用户题目不存在");
        }
        int result = delete(userQuestionMapper, id);
        return result > 0;
    }

    public UserQuestion get(Number id){
        UserQuestion in = one(userQuestionMapper, id);

        if(in == null){
            throw new ParameterException("用户题目不存在");
        }
        return in;
    }

    public Page<UserQuestion> select(int page, int pageSize){
        return select(userQuestionMapper, page, pageSize);
    }

    public List<UserQuestion> select(Collection ids){
        return select(userQuestionMapper, ids);
    }

}
